const statusCode = require("../utils/statusCodes").statusCodes;
const { getRooms } = require("../db/api.js");
const { logger } = require("../system/Logger");

async function rooms(body, res) {
    const { mailboxId, offset, limit } = body;
    getRooms(mailboxId).then((rooms) => {
        res.status(statusCode.OK).json(rooms);
    }).catch((err) => {
        logger.error(err)
        res.status(statusCode.INTERNAL_SERVER_ERROR);
    });
}

module.exports = {
    rooms,
};
